<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>503.50</title>
</head>

<body>
    <script>
        function arrayExercise() {
            // task 1: Loại bỏ các ký tự trắng của từng phần tử trong mảng
            let task1 = ["  avengers", "   captain_america", "ironman   ", " black panther   "];
            var newArr1 = new Array;
            newArr1.push(task1[0].trim());
            newArr1.push(task1[1].trim());
            newArr1.push(task1[2].trim());
            newArr1.push(task1[3].trim())

            console.log(newArr1)
            // task 2: Chuyển đổi từ dặm sang km
            var input = 1
            const mileToKm = input => {
                var km = input * 1.690
                console.log(` ${input} mile = ${km} km`)
            }
            mileToKm(input)

            // task 2: Sử dụng map + reduce tính tổng các bình phương của từng phần tử trong mảng
            var task3 = [1, 2, 3, 4, 5];
            const mapSquares = (n) => {
                var squared = n.map(function (num) {
                    return num * num
                })
                console.log(squared)
                var reduce = squared.reduce((a, b, c) => {

                    return a + b;
                })
                return reduce
            }
            console.log(mapSquares(task3))
            // task 4: Sử dụng map trả về 1 mảng mới với các phần tử được cộng thêm 4

            var task4 = [4, -4, 10];
            var map4 = task4.map((num) => {
                return num + 4;
            })
            console.log(map4)

            // task 5: Sử dụng filter + reduce tính tổng các số chẵn trong mảng
            var arr5 = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
            const task5 = (input) => {
                var filler = input.filter((num) => {
                    return num % 2 == 0
                })
                var reduce = filler.reduce((a, b) => {
                    return a + b;
                })
                return reduce
            }
            console.log(task5(arr5))

            // task 6: Chuyển các phần tử trong mảng thành chữ in hoa
            var arr6 = ["avengers", "captain america"];
            const upperCaseValue = arr6.map(val => {
                return val.toUpperCase()
            })

            console.log(upperCaseValue);
            // task 7: Thêm id vào từng phần tử object trong mảng
            var arr7 = [
                { name: 'Spider-Man' },
                { name: 'Thor' },
                { name: 'Black Panther' },
                { name: 'Captain Marvel' },
                { name: 'Silver Surfer' }
            ];
            let vId = 0;
            const task7 = arr7.map((item) => {
                return item = { id: vId++, hero: item.name }
            })
            console.log(task7)
            // task 8: Lọc các từ có độ dài lớn hơn 6
            var arr8 = ["spray", "limit", "elite", "exuberant", "destruction", "present"]
            const task8 = arr8.filter(val => {
                return val.length > 6
            })

            console.log(task8)
            // task 10: Trả về 1 mảng là bình phương của các số chẵn
            var arr10 = [11, 22, 33, 46, 75, 86, 97, 98];
            const task10 = (input) => {
                let filter = input.filter(item => {
                    return (item % 2 == 0)
                })
                let map = filter.map(val => {
                    return val * val;
                });
                return map;

            }
            console.log(task10(arr10))



        }
        arrayExercise()
    </script>

</body>

</html>